/////////////////////////////////////////////////////////////////////////
//JetDraft Software Free Panel
//Copyright (C) 2008  Maksim Timchenko

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see http://www.gnu.org/licenses/.

// FreePanelView.cpp : implementation of the CFreePanelView class
/////////////////////////////////////////////////////////////////////////

// ChildFrm.cpp : implementation of the CChildFrame class
//
#include "stdafx.h"
#include "FreePanel.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFreePanelChild
IMPLEMENT_DYNCREATE(CFreePanelChild, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CFreePanelChild, CMDIChildWnd)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()


// CFreePanelChild construction/destruction

CFreePanelChild::CFreePanelChild()
{
	n_save = 0;
	n_size_x = 0;
	n_size_y = 0;
	n_wnd_type = 0;
	n_wnd_lst_x = 0;
	n_wnd_lst_y = 0;
	m_pMainFrame = DYNAMIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
}

CFreePanelChild::~CFreePanelChild()
{

}


BOOL CFreePanelChild::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying the CREATESTRUCT cs
	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

// CFreePanelChild diagnostics

#ifdef _DEBUG
void CFreePanelChild::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CFreePanelChild::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG


// CFreePanelChild message handlers
void CFreePanelChild::OnSize(UINT nType, int cx, int cy)
{
	if(n_save == 0){
		n_wnd_type = nType;
		n_wnd_lst_x = cx;
		n_wnd_lst_y = cy;
	} else {
		nType = n_wnd_type;
		cx = n_wnd_lst_x;
		cy = n_wnd_lst_y;
	}

	CMDIChildWnd::OnSize(nType, cx, cy);
	
	if (((CFreePanelView*)this->GetActiveView())) {
		((CFreePanelView*)this->GetActiveView())->OnWindowResize(cx-n_size_x, cy-n_size_y);
	}
}

void CFreePanelChild::ActivateFrame(int nCmdShow)
{
	nCmdShow = SW_SHOWMAXIMIZED;

	CMDIChildWnd::ActivateFrame(nCmdShow);
}

int CFreePanelChild::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	ModifyStyle( WS_VSCROLL, 0 );

	return 0;
}