/////////////////////////////////////////////////////////////////////////
//JetDraft Software Free Panel
//Copyright (C) 2008  Maksim Timchenko

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see http://www.gnu.org/licenses/.

// FreePanelView.cpp : implementation of the CFreePanelView class
/////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FreePanel.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFreePanelView

IMPLEMENT_DYNCREATE(CFreePanelView, CFormView)

BEGIN_MESSAGE_MAP(CFreePanelView, CFormView)
	ON_COMMAND(ID_PL_LOAD, OnPlLoad)
	ON_COMMAND(ID_PL_SAVE, OnPlSave)
	ON_COMMAND(ID_PL_ADD_TEXT, OnPlAddText)
	ON_COMMAND(ID_PL_ADD_PICT, OnPlAddPict)
	ON_COMMAND(ID_PL_ADD_LIB, OnPlAddLib)
	ON_COMMAND(ID_PL_ADD_FILE, OnPlAddFile)
	ON_COMMAND(ID_PL_SYS_OPTIONS, OnPlSystemOptions)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CFreePanelView, CFormView)
	ON_EVENT(CFreePanelView, IDC_SHOCKWAVEFLASH1, 150, FSCommandShockwaveflash1, VTS_BSTR VTS_BSTR)
END_EVENTSINK_MAP()

// CFreePanelView construction/destruction

CFreePanelView::CFreePanelView() : CFormView(CFreePanelView::IDD)
{
	bChangeMk = true;
	bLoadEditorMk = false;
}

CFreePanelView::~CFreePanelView()
{
}

void CFreePanelView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SHOCKWAVEFLASH1, v_flash);
}

BOOL CFreePanelView::PreCreateWindow(CREATESTRUCT& cs)
{
	BOOL bPreCreated = TRUE;
	bPreCreated = CFormView::PreCreateWindow(cs);
	if( !bPreCreated )
		return FALSE;

	cs.style |= WS_CLIPSIBLINGS;

	return bPreCreated;
}

void CFreePanelView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();
	v_flash.put_Movie(m_pMainFrame->GetSelfPath() + _T("FreePanelEdit.swf"));
}

void CFreePanelView::OnWindowResize(int x_size, int y_size)
{
	//  
	v_flash.SetWindowPos(NULL, 0, 0, x_size, y_size, NULL);
	v_flash.Invalidate(TRUE);
	v_flash.UpdateWindow(); 

}

// CFreePanelView diagnostics

#ifdef _DEBUG
void CFreePanelView::AssertValid() const
{
	CFormView::AssertValid();
}

void CFreePanelView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CFreePanelDoc* CFreePanelView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFreePanelDoc)));
	return (CFreePanelDoc*)m_pDocument;
}
#endif //_DEBUG


// CFreePanelView message handlers

void CFreePanelView::OnPlLoad()
{
	CString sText, sFileExt, sFileText;

	// 
	sFileExt.LoadString(IDS_PLATFORM_FILE_EXT);
	//  
	sFileText.LoadString(IDS_PLATFORM_PROJECT_TEXT);

	if (m_pMainFrame->ShowFileDialog(TRUE, _T("*" + sFileExt), _T(sFileText + " (*" + sFileExt + ")|*" + sFileExt + "|"), &sText))
	{
		// 
		v_flash.SetVariable("v_manager_prm", "1");

		//  
		v_flash.SetVariable("v_manager_data", sText);

		// 
		v_flash.SetVariable("v_manager", "1");

		sFileName = sText;
	}
}

bool CFreePanelView::LoadFile(CString sFile)
{
	//  
	if(bLoadEditorMk){
		// 
		v_flash.SetVariable("v_manager_prm", "1");

		//  
		v_flash.SetVariable("v_manager_data", sFile);

		// 
		v_flash.SetVariable("v_manager", "1");

		sFileName = sFile;
	} else {
		//     
		sLoadFile = sFile;
	}

	return true;
}

CWnd* CFreePanelView::GetFrameParent()
{
	CWnd *wnd = GetParent();
	if(wnd != NULL){
		//       CFrameEditChild
		while (wnd->GetRuntimeClass() != RUNTIME_CLASS(CFreePanelChild)){
			wnd = wnd->GetParent();
		}
	}
	return wnd;
}

void CFreePanelView::DestroyPlView()
{
	//     
	v_flash.SetVariable("v_manager_prm", "8");
	// 
	v_flash.SetVariable("v_manager", "1");
}

void CFreePanelView::OnPlSave()
{
	// 
	v_flash.SetVariable("v_manager_prm", "2");
	// 
	v_flash.SetVariable("v_manager", "1");
}

void CFreePanelView::OnPlAddText()
{
	v_flash.SetVariable("v_manager_prm", "3");
	v_flash.SetVariable("v_manager", "1");
}

void CFreePanelView::OnPlAddPict()
{
	v_flash.SetVariable("v_manager_prm", "4");
	// 
	v_flash.SetVariable("v_manager", "1");

}
void CFreePanelView::OnPlAddLib()
{
	v_flash.SetVariable("v_manager_prm", "5");
	v_flash.SetVariable("v_manager", "1");
}
void CFreePanelView::OnPlAddFile()
{
	((CMainFrame*)::AfxGetMainWnd())->GetXmlFileList(1, ((CMainFrame*)::AfxGetMainWnd())->GetSelfPath() + _T("components\\"), _T("files_list.tfl"));

	v_flash.SetVariable("v_manager_prm", "6");
	v_flash.SetVariable("v_manager", "1");
}

void CFreePanelView::OnPlSystemOptions()
{
	v_flash.SetVariable("v_manager_prm", "7");
	v_flash.SetVariable("v_manager", "1");
}

void CFreePanelView::FSCommandShockwaveflash1(LPCTSTR command, LPCTSTR args)
{
	HANDLE hFile;
	CFile mFile;

	CString sCommand(command);
	CString s_TmpString(args);
	CString sText, sFileExt, sFileText;

	if(!sCommand.Compare("SaveFlashData")){
		sFileExt.LoadString(IDS_PLATFORM_FILE_EXT);
		sFileText.LoadString(IDS_PLATFORM_PROJECT_TEXT);
		if (m_pMainFrame->ShowFileDialog(FALSE, _T("*" + sFileExt), _T(sFileText + " (*" + sFileExt + ")|*" + sFileExt + "|"), &sText)){
			hFile = CreateFile(sText, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hFile == INVALID_HANDLE_VALUE){
				//Error
			} else {
				mFile.m_hFile = hFile;
				mFile.Write(s_TmpString, s_TmpString.GetLength());
				mFile.Close();
				sSnapShot = args;
			}
		}
	}
	if(!sCommand.Compare("SaveReflect")){
		if(sSnapShot != args){
			CString s_FileName, s_mStr;
			s_FileName = sFileName;
			s_mStr.LoadString(IDS_SAVE_CHANGES);
			int n_mMsg = AfxMessageBox(s_mStr + _T(" ")  + s_FileName + "?" , MB_YESNOCANCEL|MB_ICONEXCLAMATION);
			if(n_mMsg == IDYES){
				sText = sFileName;
				hFile = CreateFile(sText, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				if (hFile == INVALID_HANDLE_VALUE){
					//Error
				} else {
					mFile.m_hFile = hFile;
					mFile.Write(s_TmpString, s_TmpString.GetLength());
					mFile.Close();
					sSnapShot = args;
				}
			}
			if(n_mMsg == IDCANCEL){
				return;
			}
			bChangeMk = false;
			((CFreePanelChild*)GetFrameParent())->PostMessage(WM_CLOSE);
		}
	}
	if(!sCommand.Compare("LoadComplete")){
		bLoadEditorMk = true;
		if(!sLoadFile.IsEmpty()){
			LoadFile(sLoadFile);
		}
	}
	if(!sCommand.Compare("SetSnapShot")){
		sSnapShot = args;
	}
	if(!sCommand.Compare("GetMainPath")){
		v_flash.SetVariable("main_editor_path", m_pMainFrame->GetSelfPath());
	}

	//  
	if(!sCommand.Compare("CheckFileName")){
	}

	// 
	if(!sCommand.Compare("FDeleteFile")){
	}
}