/////////////////////////////////////////////////////////////////////////
//JetDraft Software Free Panel
//Copyright (C) 2008  Maksim Timchenko

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see http://www.gnu.org/licenses/.

// FreePanelView.cpp : implementation of the CFreePanelView class
/////////////////////////////////////////////////////////////////////////

// FreePanelView.h : interface of the CFreePanelView class
//

#pragma once
#include "FlashPlatform.h"

class CFreePanelView : public CFormView
{
protected: // create from serialization only
	CFreePanelView();
	DECLARE_DYNCREATE(CFreePanelView)

public:
	enum{ IDD = IDD_PLATFORM_EDIT };
	CFreePanelDoc* GetDocument() const;

	//   
protected:
	friend class CMainFrame;
	CMainFrame *m_pMainFrame;

	// Attributes
public:
	bool bChangeMk;
	bool bLoadEditorMk;
	CString	sFileName;
	CString sLoadFile;
	CString sSnapShot;
	
	// Operations
public:
	void DestroyPlView();

	// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	void OnWindowResize(int x_size, int y_size);
protected:
	CWnd* GetFrameParent();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct

	// Implementation
public:
	virtual ~CFreePanelView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	// Generated message map functions
protected:
	afx_msg void OnPlLoad();
	afx_msg void OnPlSave();
	afx_msg void OnPlAddText();
	afx_msg void OnPlAddPict();
	afx_msg void OnPlAddLib();
	afx_msg void OnPlAddFile();
	afx_msg void OnPlSystemOptions();
	DECLARE_MESSAGE_MAP()
public:
	CFlashPlatform v_flash;
public:
	bool LoadFile(CString sFile);

	DECLARE_EVENTSINK_MAP()
	void FSCommandShockwaveflash1(LPCTSTR command, LPCTSTR args);
};

#ifndef _DEBUG
inline CFreePanelDoc* CFreePanelView::GetDocument() const
{ return reinterpret_cast<CFreePanelDoc*>(m_pDocument); }
#endif