/////////////////////////////////////////////////////////////////////////
//JetDraft Software Free Panel
//Copyright (C) 2008  Maksim Timchenko

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see http://www.gnu.org/licenses/.

// FreePanelView.cpp : implementation of the CFreePanelView class
/////////////////////////////////////////////////////////////////////////

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "FreePanel.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		 sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


BOOL CMainFrame::ShowFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFilter, CString* lpFileName)
{
	CFileDialog *dlg = new CFileDialog(bOpenFileDialog, lpszDefExt,
		NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, lpszFilter);

	if (dlg->DoModal() == IDOK)
	{
		*lpFileName = dlg->GetPathName();
		delete dlg;
		return TRUE;
	}

	*lpFileName = _T("");
	delete dlg;
	return FALSE;
}

int CMainFrame::CheckDirectory(int n_RunType, CString s_WkDir)
{	
	int n_DestDir_mk = 0;
	CString s_TmpString;
	CString s_TmpFile;
	s_TmpFile.LoadString(IDS_TMP_TEST_FILE);
	s_TmpString = s_WkDir + s_TmpFile;

	HANDLE tFile = CreateFile(s_TmpString, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (tFile == INVALID_HANDLE_VALUE){
		if(!CreateDirectory(s_WkDir, NULL)){
			n_DestDir_mk = 0;
		}else{
			n_DestDir_mk = 1;
		}
	} else {
		CFile tFile(tFile);
		tFile.Close();
		DeleteFile(s_TmpString);
		n_DestDir_mk = 1;
	}
	return n_DestDir_mk; 
}

int CMainFrame::CheckFileName(int n_RunType, CString s_TmpDir, CString s_FileName)
{	
	int n_Frmt_ck = 1;
	if(n_RunType == 0 || n_RunType == 1){
		CString s_TmpFile;
		CFileFind m_finder;
		BOOL bWorking;
		s_TmpFile = s_TmpDir + s_FileName;
		bWorking = m_finder.FindFile(s_TmpFile);
		if (bWorking){
			if(n_RunType == 0){
				if(!DeleteFile(s_TmpFile)){
					n_Frmt_ck = 0;
				} else {
					n_Frmt_ck = 1;
				}
			}
			if(n_RunType == 1){
				n_Frmt_ck = 1;
			}
		} else {
			if(n_RunType == 0){
				n_Frmt_ck = 1;
			}
			if(n_RunType == 1){
				n_Frmt_ck = 0;
			}
		}
	}
	if (n_RunType == 2){
		int i = 0;
		while(s_FileName.GetLength() >= i){
			switch (s_FileName[i]){
				case '\\': n_Frmt_ck = 0;  break;
				case '/':  n_Frmt_ck = 0;  break;
				case ':':  n_Frmt_ck = 0;	break;
				case '*':  n_Frmt_ck = 0;	break;
				case '?':  n_Frmt_ck = 0;	break;
				case '"':  n_Frmt_ck = 0;	break;
				case '<':  n_Frmt_ck = 0;	break;
				case '>':  n_Frmt_ck = 0;	break;
				case '|':  n_Frmt_ck = 0;	break;
			}
			i++;
		}
	}
	return n_Frmt_ck; 
}

CString CMainFrame::GetShortName(int n_RunType, LPCTSTR lpszName)
{
	CString sText = lpszName;
	if(n_RunType == 0){
		sText.MakeReverse();
		int nPos = sText.Find("\\", 0);
		if (nPos > 0) sText.Delete(nPos, sText.GetLength() - nPos);
		nPos = sText.Find(".", 0);
		if (nPos > 0) sText.Delete(0, nPos + 1);
		sText.MakeReverse();
	}
	if(n_RunType == 1){
		sText.MakeReverse();
		int nPos = sText.Find(".", 0);
		if (nPos > 0) {
			sText = sText.Left(nPos);
		}else sText = "";
		sText.MakeReverse();
		sText.MakeLower();
	}
	if(n_RunType == 2){
		sText.MakeReverse();
		int nPos = sText.Find(".", 0);
		if (nPos > 0) {
			sText = sText.Left(nPos + 1);
		} else sText = "";
		sText.MakeReverse();
		sText.MakeLower();
	}
	return sText;
}

CString CMainFrame::GetSelfPath(void)
{
	CString s_Path, s_FilePath, s_FileFullName, s_FileName, s_File_ext;

	TCHAR buf[MAX_PATH * 2];
	::GetModuleFileName(AfxGetApp()->m_hInstance, buf, sizeof(buf)/sizeof(TCHAR));

	s_FilePath.Append(buf);
	s_FileName = CMainFrame::GetShortName(0, s_FilePath);
	s_File_ext = CMainFrame::GetShortName(2, s_FilePath);
	s_FileFullName = s_FileName + s_File_ext;
	s_Path = s_FilePath.Left(s_FilePath.GetLength() - s_FileFullName.GetLength());

	return s_Path;
}

BOOL CMainFrame::GetFileList(int n_RunType, CString sPath, CString sDirExt, CSimpleArray<CString> &sList)
{
	unsigned int uiCalculatingResult = 0;

	HANDLE hSearch;
	WIN32_FIND_DATA pFileData;

	CString strFilePath;

	strFilePath = sPath+ _T("\\*.*");

	hSearch = FindFirstFile(strFilePath, &pFileData);

	if (hSearch != INVALID_HANDLE_VALUE){
		do{
			if (!(pFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				sList.Add(sDirExt + pFileData.cFileName);
			}
			if (strcmp(pFileData.cFileName, "..") && strcmp(pFileData.cFileName, ".") && (pFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				GetFileList(n_RunType, sPath + CString(pFileData.cFileName), CString(pFileData.cFileName) + CString("\\"), sList);
			}
		}
		while (FindNextFile(hSearch, &pFileData));
	}
	
	FindClose(hSearch);
	
	return TRUE;
}

CString CMainFrame::GetFileTypeCode(int n_RunType, CString sFileName)
{	
	int i = 0;
	int n_intFileType = 0;
	BOOL bShow = FALSE;
	CString s_TmpFileExt;
	CString s_TmpFileName;
	
	i = sFileName.GetLength();
	
	while(i != -1){
		if(sFileName[i] == '.'){ break; }
		i--;
	}
	
	if(i != -1){
		sFileName.MakeLower();
		s_TmpFileExt = sFileName.Right(sFileName.GetLength() - i - 1);
		//SFW - 1
		if (!s_TmpFileExt.Compare(_T("swf"))) {n_intFileType = 1; bShow = TRUE;}
		//JPG - 2
		if (!s_TmpFileExt.Compare(_T("jpg"))) {n_intFileType = 1; bShow = TRUE;}
		//HTM - 3
		if (!s_TmpFileExt.Compare(_T("htm"))){n_intFileType = 2;}
		//HTML - 4
		if (!s_TmpFileExt.Compare(_T("html"))) {n_intFileType = 2;}
		//TXL - 5
		if (!s_TmpFileExt.Compare(_T("txl"))) {n_intFileType = 5;}
		//XML - 6
		if (!s_TmpFileExt.Compare(_T("xml"))) {n_intFileType = 4;}
		//MP3 - 7
		if (!s_TmpFileExt.Compare(_T("mp3"))) {n_intFileType = 5; bShow = TRUE;}
		//FLV - 8
		if (!s_TmpFileExt.Compare(_T("flv"))) {n_intFileType = 6; bShow = TRUE;}
		//TFN - 9
		if (!s_TmpFileExt.Compare(_T("tfn"))) {n_intFileType = 7;}
		//Default
		if (n_intFileType == 0){
			n_intFileType = -1;
		}
	} else {
		n_intFileType = 0;
	}
	if(n_intFileType == 0 && s_TmpFileExt.GetLength() != 0){
		n_intFileType = -1;
	}

	if(n_RunType == 0){
		s_TmpFileExt.Format("%d", n_intFileType);
	}
	if(n_RunType == 1){
		if(bShow){
			s_TmpFileExt.Format("%d", n_intFileType);
		} else {
			s_TmpFileExt = _T("-1");
		}
	}
		
	return s_TmpFileExt;
}

BOOL CMainFrame::GetXmlFileList(int n_RunType, CString sRootDir, CString sListName)
{	
	HANDLE hFile;
	CFile mFile;
	CSimpleArray<CString> sList;

	CString sNewStr;
	CString sHeader;
	CString sFileExt;
	CString sBody;
	CString sLabel;
	CString sLabelMiddle;
	CString sLabelClose;

	sNewStr.AppendChar(0x0d);
	sNewStr.AppendChar(0x0a);
	sHeader = _T("<?xml version='1.0'?>");
	sLabel = _T("<fl label=\"");
	sLabelMiddle = _T("\" data=\"");
	sLabelClose = _T("\"></fl>");

	if(GetFileList(n_RunType, sRootDir, _T(""), sList)){
		//Create new file
		hFile = CreateFile(sRootDir + sListName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		//Get handle
		if (hFile != INVALID_HANDLE_VALUE){
			mFile.m_hFile = hFile;
			sHeader += sNewStr;
			mFile.Write(sHeader, sHeader.GetLength());
			for(int i = 0; sList.GetSize() > i; i++){
				sFileExt = GetFileTypeCode(n_RunType, sList[i]);
				if(sFileExt.CompareNoCase(_T("-1"))){
					sBody = sLabel + sList[i] + sLabelMiddle + sFileExt + sLabelClose + sNewStr;
					mFile.Write(sBody, sBody.GetLength());
				}
			}
			mFile.Close();
		} 
	}

	return TRUE;
}